diff -Naur --exclude=CVS --exclude=configs linux/hpc/kernel.c linux-openmosix/hpc/kernel.c
--- linux/hpc/kernel.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/kernel.c	2004-04-06 21:19:38.000000000 +0200
@@ -0,0 +1,1117 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh.
+ */
+#include <linux/sched.h>
+#include <linux/hpcctl.h>
+#include <linux/hpc.h>
+#include <net/tcp.h>
+#include <hpc/dscosts.h>
+#include <hpc/mfscosts.h>
+#include <hpc/protocol.h>
+#include <linux/mm.h>
+#include <linux/smp_lock.h>
+#include <linux/slab.h>
+#include <linux/stddef.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <hpc/hpcversion.h>
+#include <hpc/comm.h>
+#include <hpc/balance.h>
+#include <hpc/debug.h>
+#include <asm/ptrace.h>
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
+/************* some MOSIX global variables: *************/
+
+spinlock_t mosix_flag = SPIN_LOCK_UNLOCKED;
+spinlock_t whereto_lock = SPIN_LOCK_UNLOCKED;
+int active_cpus;
+int cpuspeed = STD_SPD;
+int standard_speed = STD_SPD;
+int mosix_running; /* is openMosix running 1=yes */
+struct task_struct *chosen_for_balance, *chosen_for_mdp;
+
+
+struct mosix_cost mosix_cost[MAX_MOSIX_TOPOLOGY] =
+{{
+	PAGE_COST_D, PAGE_COST_R,
+	SYSCALL_COST_D, SYSCALL_COST_R,
+	COPYOUT_COST_BASE_D, COPYOUT_COST_PER_KB_D,
+	COPYOUT_COST_BASE_R, COPYOUT_COST_PER_KB_R,
+	COPYIN_COST_BASE_D, COPYIN_COST_PER_KB_D,
+	COPYIN_COST_BASE_R, COPYIN_COST_PER_KB_R,
+	MIGRATION_COST_BASIC, MIGRATION_COST_PER_PAGE
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	, 0, 0
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+}};
+
+struct mfs_cost mfs_cost[MAX_MOSIX_TOPOLOGY] =
+{{
+	MFS_COST_CONN_S, MFS_COST_CONN_C,
+	MFS_COST_INKB_S, MFS_COST_INKB_C,
+	MFS_COST_OUTKB_S, MFS_COST_OUTKB_C,
+}};
+
+struct opcost deputy_here[MAX_MOSIX_TOPOLOGY];
+struct task_struct *info_proc;
+int info_daemon_active = 0;
+
+/**************************************************/
+
+int
+balpriority(int w)
+{
+	switch(w)
+	{
+	case MUSTGOHOME:
+		return(7);
+	case GOBACKHOME:
+		return(6);
+	default:
+		return(5);
+	case MFSBALANCE:
+		return(4);
+	case IOBALANCE:
+		return(3);
+	case MEMBALANCE:
+		return(2);
+	case BALANCE:
+		return(1);
+	case 0:
+		return(0);
+	}
+	/*NOTREACHED*/
+}
+
+inline void
+mosix_do_add_to_whereto(struct task_struct *p, int w)
+{
+	if(balpriority(p->mosix.whereto) >= balpriority(w))
+		return;
+	p->mosix.whereto = w;
+	if(w != BALANCE && p == chosen_for_balance)
+	{
+		free_task_struct(p);
+		chosen_for_balance = NULL;
+	}
+	if(w != MEMBALANCE && p == chosen_for_mdp)
+	{
+		free_task_struct(p);
+		chosen_for_mdp = NULL;
+	}
+	if((p->mosix.dflags & (DREMOTE|DSENTURGENT)) != (DREMOTE|DSENTURGENT))
+		wake_up_mosix(p);
+}
+
+void
+mosix_add_to_whereto(struct task_struct *p, int w)
+{
+	spin_lock_irq(&whereto_lock);
+	mosix_do_add_to_whereto(p, w);
+	spin_unlock_irq(&whereto_lock);
+}
+
+/*
+ * must = 0: normal priority - if it fails, return.
+ * must = 1: high priority - but still return if it fails.
+ * must = 2: high priority and die (never return) on failure.
+ * otherwise, return 1 on success, 0 on failure.
+ * WARNING: do not call with "must==2" where resources were allocated.
+ */
+int
+mosix_go_home(int must)
+{
+	register struct task_struct *p = current;
+
+	if(p->mosix.dflags & DDEPUTY)
+	{
+		if(current->mosix.dflags & DINCOMING)
+			/* (eg. within do_mmap while migrating back) */
+			return(1);
+		passto(must ? MUSTGOHOME : GOBACKHOME, 0);
+	}
+	else if(p->mosix.dflags & DREMOTE)
+	{
+		remote_request(must ? REM_MUST_COME_HOME : REM_BRING_ME_HOME,
+			NULL, 0, NULL, 0, 0, NULL, 0);
+		/* should not return, but */
+	}
+	if(p->mosix.dflags & (DDEPUTY|DREMOTE))
+	{
+		printk("%s: Failed to Go Back Home.\n", desc_mostask(NULL));
+		if(must < 2)
+			return(0);
+		if(p->mosix.dflags & DDEPUTY)
+		{
+			printk("Process %s, uid=%d, killed because it failed to migrate back here\n",
+				desc_mostask(NULL), p->uid);
+			printk("(possible reasons are lack of space on swap-space, or network disconnection)\n");
+			do_exit(SIGKILL);
+		}
+		else
+			remote_disappear();
+	}
+	return(1);
+}
+
+int
+mosix_go_home_for_reason(int must, int reason)
+{
+	struct task_struct *p = current;
+	int ret;
+
+	task_lock(p);
+	if((p->mosix.stay & reason) && (p->mosix.dflags & (DDEPUTY|DREMOTE)))
+		panic("mosix_go_home_for_reason: why not earlier?");
+	p->mosix.stay |= reason;
+	task_unlock(p);
+	if(!(ret = mosix_go_home(must)))
+	{
+		task_lock(p);
+		p->mosix.stay &= ~reason;
+		task_unlock(p);
+	}
+	return(ret);
+}
+
+int
+stay_me_and_my_clones(uint32_t reasons)
+{
+	struct task_struct *p, *me = current;
+	struct mm_struct *mm = me->mm;
+
+	if(me->mosix.dflags & DDEPUTY)
+		return(!mosix_go_home(1));	/* there are no clones! */
+	task_lock(me);
+	me->mosix.stay |= reasons;
+	task_unlock(me);
+	if(atomic_read(&mm->mm_realusers) > 1)
+	{
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+		if(p->mm == mm && p != me)
+		{
+			task_lock(p);
+			if(p->mm == mm)
+				p->mosix.stay |= reasons;
+			task_unlock(p);
+		}
+		read_unlock(&tasklist_lock);
+	}
+	return(0);
+}
+
+void
+unstay_mm(struct mm_struct *mm)
+{
+	struct task_struct *p;
+
+	if(atomic_read(&mm->mm_realusers) == 1 && mm == current->mm)
+	{
+		if(!(current->mosix.dflags & DREMOTE))
+			tell_process(current, DREQ_CHECKSTAY);
+		return;
+	}
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if(p->mm == mm)
+		tell_process(p, DREQ_CHECKSTAY);
+	read_unlock(&tasklist_lock);
+}
+
+int
+mosix_wakeable(struct task_struct *p)
+{
+#ifdef CONFIG_MOSIX_DFSA
+	/* the following side-effect of this boolean function is allowed
+	 * because it is only called by "wake_up_mosix" and it is a good
+	 * practice to hide such MOSIX details from "wake_up_mosix".
+	 * note that we are already protected by runqueue_lock,
+	 * making DREMOTEDFSA, DINSCHED and DHEAVYSLEEP stable.
+	 */
+	if(p->mosix.dflags & DREMOTEDFSA)
+	{
+		tell_process(p, DREQ_EXITDFSA);
+		return(!(p->state & TASK_UNINTERRUPTIBLE) &&
+			!(p->mosix.dflags & (DINSCHED|DHEAVYSLEEP)));
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	if(p->mosix.dflags & (DINSCHED|DFAKESIGNAL|DHEAVYSLEEP|DFINISHED))
+		return(0);
+	if(p->state & TASK_UNINTERRUPTIBLE)
+		return(0);
+	if(p->mosix.dflags & DREMOTE)
+	{
+		if(!remote_need_while_asleep(p))
+			return(0);
+	}
+	return(1);
+}
+
+/*
+ * the following two boolean routines are very sensitive,
+ * it may not even lock the kernel or mosix, so if there is any need to do so,
+ * it must return 1.
+ */
+
+int
+remote_need_while_asleep(struct task_struct *p)
+{
+	/* if DREQ_CHECKCONF is set, we can't even call
+	 * "i_am_in_a_wrong_place()", since it uses locks
+	 */
+	return((process_told(p, DREQ_CHECKCONF) &&
+			p->mosix.whereto != MUSTGOHOME) ||
+		process_told(p, DREQ_EXITDFSA) ||
+		(URGENT_REMOTE_CONDITIONS(p) &&
+		!(p->mosix.dflags & (DSENTURGENT|DPASSING|DINCOMING))));
+}
+
+/*
+ * called from schedule() with the runqueue_lock locked.
+ */
+int
+mosix_need_while_asleep(void)
+{
+	register struct task_struct *p = current;
+	register struct mosix_task *m = &p->mosix;
+
+#ifdef CONFIG_MOSIX_DFSA
+	if((m->dflags & DREMOTEDFSA) && (process_told(p, DREQ_EXITDFSA)))
+	{
+		process_ack(p, DREQ_EXITDFSA);
+		spin_lock_irq(&p->sigmask_lock);
+		m->dflags |= DFAKESIGNAL;
+		if(!(m->dflags & DHEAVYSLEEP))
+		{
+			p->sigpending = 1;
+			set_current_state(TASK_RUNNING);
+		}
+		spin_unlock_irq(&p->sigmask_lock);
+		return(0);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	if(m->dflags & (DINSCHED|DFAKESIGNAL|DHEAVYSLEEP))
+		return(0);
+	if(m->dflags & DREMOTE)
+		return(remote_need_while_asleep(p));
+	if(m->dirty_bits & MMAP_MMDOWNED)
+		return(0);
+	if(m->prequest)
+		return(1);
+	if(process_told(p, (DREQ_NICECNG|DREQ_UPDOVERHEADS|DREQ_CHECKCONF|
+		DREQ_INFOCNG|DREQ_DFSASYNC|DREQ_CAPCNG|DREQ_CHECKSTAY|
+		DREQ_URGENT)))
+		return(1);
+	if(m->whereto)
+		return(1);
+	if((m->dflags & DDEPUTY) && (m->stay & DSTAY))
+		return(1);
+	return(0);
+}
+
+void
+remote_run_while_asleep(void)
+{
+	struct task_struct *p = current;
+
+	if(process_told(p, DREQ_CHECKCONF))
+	{
+		if(i_am_in_a_wrong_place())
+			mosix_add_to_whereto(current, MUSTGOHOME);
+		/* else DREQ_CHECKCONF is cleared */
+	}
+	if(URGENT_REMOTE_CONDITIONS(p) &&
+			!(p->mosix.dflags & (DSENTURGENT|DPASSING|DINCOMING)))
+		inform_deputy_of_urgent();
+}
+
+void
+deputy_run_while_asleep(void)
+{
+	register struct task_struct *p = current;
+
+	if(p->mosix.dflags & DSYNC)
+		deputy_async_requests();
+	else
+	{
+		p->mosix.dflags |= DFAKESIGNAL;
+		evaluate_pending_signals_in_mosix_context();
+	}
+}
+
+void
+mosix_run_while_asleep(void)
+{
+	register struct task_struct *p = current;
+	register struct mosix_task *m = &p->mosix;
+
+	if(m->dflags & DREMOTE)
+	{
+		remote_run_while_asleep();
+		return;
+	}
+	scan:
+	if(m->dflags & DDEPUTY)
+	{
+		deputy_run_while_asleep();
+		if(mosix_need_while_asleep())
+			goto scan;
+		return;
+	}
+	/* LOCAL PROCESSES */
+	if(m->prequest)
+	{
+		process_requests();
+		goto scan;
+	}
+	process_ack(p, DREQ_NICECNG|DREQ_INFOCNG|DREQ_UPDOVERHEADS|DREQ_URGENT);
+	if(m->whereto)
+	{
+		follow_whereto();
+		goto scan;
+	}
+	if(process_told(p, DREQ_CHECKCONF))
+	{
+		done_checking_conf();
+		goto scan;
+	}
+	if(process_told(p, DREQ_CHECKSTAY))
+	{
+		if(p->mm)
+			down_read(&p->mm->mmap_sem);
+		mosix_check_for_freedom_to_move();
+		if(p->mm)
+			up_read(&p->mm->mmap_sem);
+		goto scan;
+	}
+	if(process_told(p, DREQ_CAPCNG))
+	{
+		sync_caps();
+		goto scan;
+	}
+#ifdef CONFIG_MOSIX_DFSA
+	if(process_told(p, DREQ_DFSASYNC))
+	{
+		clear_dfsasync();
+		goto scan;
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+}
+
+int
+remote_pre_usermode_actions(void)
+{
+	struct task_struct *p = current;
+	struct mosix_task *m = &p->mosix;
+	int i, nfsigs;
+	siginfo_t *fsigs;
+
+	loop:
+	do_decay();
+	if(remote_deputy_has_something_for_us(p))
+	{
+		wait_for_permission_to_continue();
+		goto loop;
+	}
+	if(process_told(p, DREQ_CHECKCONF) && i_am_in_a_wrong_place())
+		mosix_add_to_whereto(p, MUSTGOHOME);
+	if(URGENT_REMOTE_CONDITIONS(p) && !(m->dflags & DSENTURGENT))
+	{
+		inform_deputy_of_urgent();
+		goto loop;
+	}
+	if(m->asig || m->nforced_sigs)
+	{
+		spin_lock_irq(&p->sigmask_lock);
+		i = m->asig;
+		m->asig = 0;
+		fsigs = m->forced_sigs;
+		nfsigs = m->nforced_sigs;
+		m->forced_sigs = NULL;
+		m->nforced_sigs = 0;
+		spin_unlock_irq(&p->sigmask_lock);
+		transfer_signals_to_deputy((unsigned int) i, fsigs, nfsigs);
+		if(fsigs)
+			kfree(fsigs);
+		goto loop;
+	}
+	return(0);
+}
+
+int
+local_pre_usermode_actions(void)
+{
+	struct task_struct *p = current;
+	int any = 0;
+
+	while(1)
+	{
+		do_decay();
+		if(p->mosix.whereto)
+		{
+			follow_whereto();
+			any = 1;
+			if(p->mosix.dflags & DDEPUTY)
+				return(1);
+			continue;
+		}
+		if(process_told(p, DREQ_CHECKCONF))
+		{
+			done_checking_conf();
+			any = 1;
+			continue;
+		}
+		if(process_told(p, DREQ_CAPCNG))
+		{
+			sync_caps();
+			any = 1;
+			continue;
+		}
+#ifdef CONFIG_MOSIX_DFSA
+		if(process_told(p, DREQ_DFSASYNC))
+		{
+			clear_dfsasync();
+			any = 1;
+			continue;
+		}
+#endif /* CONFIG_MOSIX_DFSA */
+		if(process_told(p, DREQ_CHECKSTAY))
+		{
+			down_read(&p->mm->mmap_sem);
+			mosix_check_for_freedom_to_move();
+			up_read(&p->mm->mmap_sem);
+			any = 1;
+			continue;
+		}
+		process_ack(p, DREQ_NICECNG|DREQ_INFOCNG|DREQ_UPDOVERHEADS|
+								DREQ_URGENT);
+		return(any);
+	}
+}
+
+int
+mosix_pre_usermode_actions(struct pt_regs regs)
+{
+	register struct task_struct *p = current;
+	int any = 0;
+
+	if((regs.xcs & 3) != 3)	/* going back to kernel -- not to user mode */
+		return(0);
+	__sti();		/* could be called after an interrupt */
+
+	if(p->mosix.dflags & DREMOTE)
+		return(remote_pre_usermode_actions());
+
+	while(1)
+	{
+		if(p->mosix.dflags & DDEPUTY)
+		{
+			deputy_main_loop();
+			p = current;	/* fork? */
+			any = 1;
+			continue;
+		}
+		if(local_pre_usermode_actions())
+		{
+			any = 1;
+			continue;
+		}
+		if(p->mosix.prequest)
+		{
+			process_requests();
+			any = 1;
+			continue;
+		}
+		return(any);
+	}
+}
+
+int
+mosix_fork_init_fields(struct task_struct *p)
+{
+	struct mosix_task *m = &p->mosix;
+	struct task_struct *parent = current;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	int ii;
+#endif
+#ifdef CONFIG_MOSIX_DFSA
+	tell_process(parent, DREQ_NOTUPTODATE);
+	tell_process(p, DREQ_NOTUPTODATE);
+	if(parent->mosix.dflags & (DREMOTEDAEMON|DREMOTE))
+		dfsa_tinit();
+	m->ttab = NULL;
+#endif /* CONFIG_MOSIX_DFSA */
+	if(!(parent->mosix.dflags & DDEPUTY))
+		tell_process(p, DREQ_CHECKSTAY);
+	m->dflags = parent->mosix.dflags & ~(DREMOTEDAEMON|DSENTURGENT);
+	process_ack(p, DREQ_HOMEWAKE|DREQ_URGENT);
+	m->commpri = 0;
+	if(parent->mosix.dflags & DREMOTEDAEMON)
+	{
+		m->dflags |= DREMOTE|DHEAVYSLEEP;
+		m->hsleep_count = 1;
+	}
+	else if(parent->mosix.dflags & DREMOTE)
+	{ 
+		/* this information comes from the parent task struct,
+                   which we copied into out task struct in kernel/do_fork.c 
+		*/
+                m->mypid = m->sonpid;
+                m->depinfo.tgid = m->sontgid;
+                sprintf(p->comm, "remote(%d)", m->mypid);
+	}
+	if(parent->mosix.dflags & DDEPUTY)
+		m->dflags &= ~(DDEPUTY|DSYNC);
+	if(!(parent->mosix.dpolicy & DADV_INHERIT))
+	{
+		m->dpolicy = DADV_DEFAULT;
+#if DADV_DEFAULT == DADV_OWNDECAY
+		m->decay = DECAY_QUOTIENT;
+		m->deccycle = DEFAULT_DECAY_INTERVAL;
+#endif
+	}
+	if(p->pid == 1)
+		m->stay |= DSTAY_SYSTEM;
+	else
+		m->stay &= ~DSTAY_SYSTEM;
+	m->held_files = NULL;
+	m->held_allocated = 0;
+	rwlock_init(&m->state_lock);
+	m->contact = 0;
+	m->ucache = NULL;
+	m->prequest = NULL;
+	if(parent->mm == &init_mm || !parent->mm ||
+		(parent->mosix.dflags & DDEPUTY) ||
+		(parent->mosix.stay & DSTAY_SYSTEM))
+		m->ancesstor = NULL;
+	else
+		m->ancesstor = parent;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	for (ii = 0; ii < smp_num_cpus; ii++)
+	{
+		m->last_per_cpu_utime[ii] = 0;
+		m->last_per_cpu_stime[ii] = 0;
+	}
+#endif
+	m->last_sigxcpu = 0;
+	m->deputytime = 0;
+	m->passedtime = 0;
+	m->uttime = 0;
+	m->dctime = 0;
+	m->ndemandpages = 0;
+	m->nsyscalls = 0;
+	m->ncopyouts = 0;
+	m->copyoutbytes = 0;
+	m->ncopyins = 0;
+	m->copyinbytes = 0;
+	m->iocounter = 0;
+	m->cutime = 0;
+	m->last_consider = 0;
+	m->last_mconsider = 0;
+	m->decsecs = 0;
+	memset((caddr_t)&m->asig, 0, sizeof(m->asig));
+	m->forced_sigs = 0;
+	m->nforced_sigs = 0;
+	m->pages_i_bring = 0;
+	m->page_allocs = 0;
+	m->ran = 0;
+	m->runstart = 0;
+	m->load = 0;
+	m->inexec = NULL;
+	m->nmigs = 0;
+	m->pass_regs = 0;
+	init_waitqueue_head(mos_to_waitp(m));
+	m->mosix_log = NULL;
+	m->dirty_bits = 0;
+#ifdef CONFIG_MOSIX_FS
+	m->mfs_stats = NULL;
+#endif /* CONFIG_MOSIX_FS */
+	return(fork_mosix_remote_files(p));
+}
+
+void
+mosix_fork_free_fields(struct task_struct *p)
+{
+	if(p->mosix.dflags & DDEPUTY)
+		undeputy(p);
+}
+
+void
+mosix_exit(void)
+{
+	struct task_struct *p = current;
+	struct mosix_task *m = &p->mosix;
+	unsigned int i;
+	struct linux_binprm *bprm = m->inexec;
+
+	lock_mosix();
+	write_lock_irq(&tasklist_lock);
+	spin_lock(&runqueue_lock);
+	m->dflags |= DFINISHED;
+	m->bstate = TASK_SAME;/* we are not going back to original sleep/stop */
+	spin_unlock(&runqueue_lock);
+	write_unlock_irq(&tasklist_lock);
+	unlock_mosix();
+	m->pages_i_bring = 0;
+	unchoose_me();
+	free_ucache();
+	if(m->dflags & DDEPUTY)
+		mosix_deputy_rusage(1); /* (includes setting "m->exit_mem") */
+	if(m->dflags & DREMOTE)
+		expel_progress = 1;
+	if(m->dflags & (DDEPUTY|DREMOTE))
+		comm_close(NULL); /* for a DEPUTY, this will kill our REMOTE */
+	if(m->dflags & DDEPUTY)
+		undeputy(p);
+	if(process_told(p, DREQ_CHECKCONF))
+		done_checking_conf();
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_exit();
+#endif /* CONFIG_MOSIX_DFSA */
+	if(bprm)
+	{
+		for(i = 0 ; i < MAX_ARG_PAGES ; i++)
+		if(bprm->page[i])
+			__free_page(bprm->page[i]);
+		if(m->dflags & DREMOTE)
+			kfree(bprm);
+	}
+	if(m->prequest)
+		discard_requests();
+}
+
+void
+mosix_very_exit(void)
+{
+	struct task_struct *p = current, *a;
+	struct mosix_task *m = &p->mosix;
+	struct task_struct *q;
+#ifdef CONFIG_MOSIX_FS
+	struct mfs_stats *mfst;
+#endif /* CONFIG_MOSIX_FS */
+
+#ifdef CONFIG_MOSIX_FS
+	lock_mosix();
+	mfst = m->mfs_stats;
+	m->mfs_stats = NULL;
+	unlock_mosix();
+	if(mfst)
+		kfree(mfst);
+#endif /* CONFIG_MOSIX_FS */
+	read_lock(&tasklist_lock);
+	if((a = m->ancesstor))
+		get_task_struct(a);
+	for_each_task(q)
+	if(q->mosix.ancesstor == p)
+		q->mosix.ancesstor = a;
+	read_unlock(&tasklist_lock);
+	if(a)
+	{
+		add_statistics_to_ancesstor(p, a);
+		free_task_struct(a);
+	}
+	if(m->forced_sigs)
+	{
+		kfree(m->forced_sigs);
+		m->nforced_sigs = 0;
+	}
+}
+
+void
+mosix_obtain_registers(unsigned long mask)
+{
+	register struct mosix_task *m = &current->mosix;
+	unsigned int bringme;
+
+	if(mask & ~ALL_REGISTERS)
+		panic("(open)mosix_obtain_registers, mask=0x%x", (int)mask);
+	if(m->dflags & DDEPUTY)
+	{
+		if((bringme = mask & ~m->deputy_regs))
+		{
+			if(deputy_request(DEP_BRING_ME_REGS, &bringme,
+				sizeof(bringme), NULL, 0, 0, NULL, 0))
+				deputy_communication_failed();
+			else if((m->deputy_regs & mask) != mask)
+			{
+				send_sig(SIGKILL, current, 1);
+			}
+		}
+	}
+	else if(m->dflags & DREMOTE)
+	{
+		if((bringme = mask & m->deputy_regs))
+		{
+			if(remote_request(REM_BRING_ME_REGS, &bringme,
+				sizeof(bringme), NULL, 0, 0, NULL, 0))
+				send_sig(SIGKILL, current, 1);
+			else if((~m->deputy_regs & mask) != mask)
+			{
+				send_sig(SIGKILL, current, 1);
+				mosix_panic("remote-regs");
+			}
+		}
+	}
+}
+
+unsigned int
+which_regs_to_send()
+{
+	register struct mosix_task *m = &current->mosix;
+
+	if(!m->pass_regs)
+		return(0);
+	return(m->pass_regs &
+		((m->dflags & DDEPUTY) ? m->deputy_regs : ~m->deputy_regs));
+}
+
+void
+regs_were_sent(void)
+{
+	register struct mosix_task *m = &current->mosix;
+
+	if(m->dflags & DDEPUTY)
+		m->deputy_regs &= ~m->pass_regs;
+	else
+		m->deputy_regs |= m->pass_regs; 
+	m->pass_regs = 0;
+}
+
+void
+mosix_bring_monkey_users_back(struct inode *ip)
+{
+	register struct task_struct *p, *found, *me = current;
+	DECLARE_WAITQUEUE(wait, me);
+
+	while(1)
+	{
+		found = NULL;
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+		if(p != me && !(p->mosix.dflags & DREMOTE) &&
+			task_maps_ip(p, ip))
+		{
+			task_lock(p);
+			p->mosix.stay |= DSTAY_FOR_MONKEY;
+			task_unlock(p);
+			if(p->mosix.dflags & DDEPUTY)
+			{
+				tell_process(p, DREQ_HOMEWAKE);
+				wake_up_mosix(p);
+				if(!found)
+				{
+					found = p;
+					get_task_struct(p);
+				}
+			}
+		}
+		if(!found)
+		{
+			read_unlock(&tasklist_lock);
+			/* VMODIFIED is needed against a nearly-impossible
+			 * REMOTE race, when ip is modified, then unmonkied
+			 * and a process migrates there even before the
+			 * previous completed exiting:
+			 */
+			OPENMOSIX_VMODIFIED(ip);
+			return;
+		}
+		set_current_state(TASK_UNINTERRUPTIBLE);
+		add_wait_queue(mos_to_waitp(&found->mosix), &wait);
+		read_unlock(&tasklist_lock);
+		schedule();
+		remove_wait_queue(mos_to_waitp(&found->mosix), &wait);
+		set_current_state(TASK_RUNNING);
+		free_task_struct(found);
+	}
+}
+
+void
+mosix_no_longer_monkey(struct inode *ip)
+{
+	register struct task_struct *p;
+
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if(!(p->mosix.dflags & (DREMOTE|DDEPUTY)) && task_maps_ip(p, ip))
+	{
+		tell_process(p, DREQ_CHECKSTAY);
+		wake_up_mosix(p);
+	}
+	read_unlock(&tasklist_lock);
+}
+
+/*
+ * caller is responsible to down_[read|write](&current->mm->mmap_sem)
+ * (unless deemed unnecessary - as in "exec" or after migrating back,
+ * when we are sure to have no clones.
+ */
+void
+mosix_check_for_freedom_to_move(void)
+{
+	struct task_struct *p = current;
+	register struct vm_area_struct *mpnt;
+	register struct inode *ip;
+	int stay;
+	struct mm_struct *mm;
+
+	if(p->mosix.dflags & DDEPUTY)
+	{
+		return;
+	}
+	process_ack(p, DREQ_CHECKSTAY);
+	if(!(p->mosix.stay & (DSTAY_PER_MM|DSTAY_FOR_CLONE)))
+		return;
+	task_lock(p);
+	stay = p->mosix.stay & ~(DSTAY_PER_MM|DSTAY_FOR_CLONE);
+	if(!(mm = current->mm))
+		stay |= DSTAY_FOR_CLONE;
+	else
+	{
+		if(atomic_read(&mm->mm_kiocount))
+			stay |= DSTAY_FOR_KIOBUF;
+		if(atomic_read(&mm->mm_realusers) > 1)
+			stay |= DSTAY_FOR_CLONE;
+		if(mm->def_flags & VM_LOCKED)
+			stay |= DSTAY_FOR_MLOCK;
+		for(mpnt = mm->mmap ; mpnt ; mpnt = mpnt->vm_next)
+		{
+			if(mpnt->vm_file)
+			{
+				mode_t mode;
+
+				ip = mpnt->vm_file->f_dentry->d_inode;
+				mode = ip->i_mode;
+				if(ip->i_mapping->i_mmap_shared)
+					stay |= DSTAY_FOR_MONKEY;
+				if(S_ISCHR(mode) || S_ISFIFO(mode) ||
+								S_ISSOCK(mode))
+					stay |= DSTAY_FOR_DEV;
+			}
+			if(mpnt->vm_flags & VM_LOCKED)
+				stay |= DSTAY_FOR_MLOCK;
+		}
+	}
+	p->mosix.stay = stay;
+	task_unlock(p);
+}
+
+/*
+ * caller must use 'get_task_struct(p)'
+ */
+int
+mosix_send_back_home(struct task_struct *p)
+{
+	struct task_struct *me = current;
+	int timeout = 20 * HZ;
+	DECLARE_WAITQUEUE(wait, me);
+
+	if(p == me)
+		return(mosix_go_home(1) ? 0 : -ENOMEM);
+
+	/* there is a paranoidic possibility of a tricky deadlock: if two
+	 * (or more) remote processes send each other home simultaneously:
+	 * we want to sleep interruptibly, so we can migrate, but no signals
+	 * should stop us - unless the other process failed to migrate for a
+	 * very long time.  e.g. we are to give up only with the combination
+	 * of a signal + timeout.
+	 */
+	add_wait_queue(mos_to_waitp(&p->mosix), &wait);
+	while(p->mosix.dflags & DDEPUTY)
+	{
+		tell_process(p, DREQ_HOMEWAKE);
+		mosix_add_to_whereto(p, MUSTGOHOME);
+		spin_lock_irq(&me->sigmask_lock);
+		me->mosix.ignoreoldsigs = 1;
+		me->sigpending = 0;
+		spin_unlock_irq(&me->sigmask_lock);
+		set_current_state(TASK_INTERRUPTIBLE);
+		task_lock(p);
+		if(!(p->mosix.dflags & DDEPUTY))
+			set_current_state(TASK_RUNNING);
+		task_unlock(p);
+		timeout = schedule_timeout(timeout);
+		if(timeout <= 0)
+		{
+			spin_lock_irq(&me->sigmask_lock);
+			recalc_sigpending(me);
+			spin_unlock_irq(&me->sigmask_lock);
+			if(signal_pending(current))
+			{
+				remove_wait_queue(mos_to_waitp(&p->mosix),
+									&wait);
+				free_task_struct(p);
+				return(-EINTR);
+			}
+			timeout = HZ;
+		}
+	}
+	set_current_state(TASK_RUNNING);
+	remove_wait_queue(mos_to_waitp(&p->mosix), &wait);
+	spin_lock_irq(&me->sigmask_lock);
+	recalc_sigpending(me);
+	spin_unlock_irq(&me->sigmask_lock);
+	return(0);
+}
+
+void
+mosix_pre_dropping_mm(struct task_struct *myself, struct mm_struct *mm)
+{
+	register struct task_struct *p;
+
+	if(!mm)
+		return;
+	atomic_dec(&mm->mm_realusers);
+	if(atomic_read(&mm->mm_realusers) == 1)
+	{
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+		if(p != myself && p->mm == mm)
+		{
+			tell_process(p, DREQ_CHECKSTAY);
+			break;
+		}
+		read_unlock(&tasklist_lock);
+	}
+}
+
+void
+mosix_exit_mm(struct task_struct *p)
+{
+	if((p->mosix.dflags & (DPASSING|DREMOTE)) == DPASSING)
+		return;
+	if(p->mosix.held_files)
+		mosix_clear_all_held_files(p);
+	if(!(p->mosix.dflags & DDEPUTY))
+		mosix_pre_dropping_mm(p, p->mm);
+	task_lock(p);
+	p->mosix.stay = (p->mosix.stay | DSTAY_FOR_CLONE) & ~DSTAY_PER_MM;
+	task_unlock(p);
+	p->mosix.pages_i_bring = 0;
+}
+
+void
+mosix_exec_mmap(struct mm_struct *old_mm)
+{
+	struct task_struct *p = current;
+
+	if(p->mosix.dflags & DDEPUTY)
+		return;
+		
+	mosix_pre_dropping_mm(p, old_mm);
+	task_lock(p);
+	p->mosix.stay &= ~(DSTAY_PER_MM|DSTAY_FOR_CLONE);
+	task_unlock(p);
+	p->mosix.pages_i_bring = 0;
+	if(p->mosix.held_files)
+		mosix_clear_all_held_files(p);
+}
+
+int
+mosix_pre_clone(void)
+{
+	struct task_struct *p = current;
+
+	if(!mosix_go_home(0))
+		return(-ENOMEM);
+	
+	/* prevent race with "mosix_pre_dropping_mm" */
+	if(p->mm)
+		atomic_inc(&p->mm->mm_realusers);
+	read_lock(&tasklist_lock);
+	task_lock(p);
+	p->mosix.stay |= DSTAY_FOR_CLONE;
+	task_unlock(p);
+	read_unlock(&tasklist_lock);
+	return(0);
+}
+
+void
+mosix_post_clone(void)
+{
+	struct task_struct *p = current;
+	struct mm_struct *mm = p->mm;
+
+	if(mm)
+	{
+		atomic_dec(&mm->mm_realusers);
+		read_lock(&tasklist_lock);
+		if(atomic_read(&mm->mm_realusers) == 1)
+		{
+			task_lock(p);
+			p->mosix.stay &= ~DSTAY_FOR_CLONE;
+			task_unlock(p);
+		}
+		read_unlock(&tasklist_lock);
+	}
+}
+
+/* 'run_on' and 'run_off' must be called with the runqueue_lock! */
+void
+run_on(struct task_struct *p)
+{
+	if(!(p->mosix.dflags & DPAGEIN))
+	{
+		mosix_running++;
+		p->mosix.runstart = load_ticks + 1;
+	}
+}
+
+void
+run_off(struct task_struct *p)
+{
+	if(!(p->mosix.dflags & DPAGEIN))
+	{
+		mosix_running--;
+		p->mosix.ran += load_ticks + 1 - p->mosix.runstart;
+		p->mosix.runstart = 0;
+	}
+}
+
+void
+down_half_interruptible(struct semaphore *sem)
+{
+	struct task_struct *p = current;
+
+	do
+	{
+		spin_lock_irq(&p->sigmask_lock);
+		p->mosix.ignoreoldsigs = 1;
+		p->sigpending = 0;
+		spin_unlock_irq(&p->sigmask_lock);
+	}
+	while(down_interruptible(sem) == -EINTR);
+	recalc_sigpending(p);
+}
+
+/* still to be implemented: to adapt to the changes made in 2.4.19 - Amit. */
+/*
+void
+down_half_rw_interruptible(struct rw_semaphore *sem)
+{
+	struct task_struct *p = current;
+
+	do {
+		spin_lock_irq(&p->sigmask_lock);
+		p->mosix.ignoreoldsigs = 1;
+		p->sigpending = 0;
+		spin_unlock_irq(&p->sigmask_lock);
+	}
+	while(down_interruptible(sem) == -EINTR);
+	recalc_sigpending(p);
+}
+*/
